import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

Widget CustomCardfunc(CustomCard custom_card) {
  IconPrameters iconPrameters = new IconPrameters(size: custom_card.icon1_size, color: custom_card.icon1_color, icon_value: custom_card.icon1_value);
  IconPrameters iconPrameters1 = new IconPrameters(size: custom_card.icon2_size, color: custom_card.icon2_color, icon_value: custom_card.icon2_value);

  outlineButtonParameters buttonParameters = new outlineButtonParameters(
    child: custom_card.Textchild,
    onpressed: custom_card.Textonpressed,
    pad_val_top_wrap: custom_card.Textpad_val_top_wrap,
    pad_val_r_wrap: custom_card.Textpad_val_r_wrap,
    pad_val_l_wrap: custom_card.Textpad_val_l_wrap,
    pad_val_bottom_wrap: custom_card.Textpad_val_bottom_wrap,
  );
  OutlineButton_param outlineButton_param = new OutlineButton_param(
    child: custom_card.oulineButton1child,
    radius: custom_card.oulineButton1radius,
    color: custom_card.oulineButton1color,
    pad_val_l_wrap: custom_card.oulineButton1pad_val_l_wrap,
    pad_val_top_wrap: custom_card.oulineButton1pad_val_top_wrap,
    function: custom_card.oulineButton1function,
  );
  Img_Container containeri = new Img_Container(
    // width: custom_card.imagecontainerwidth,
    height: custom_card.imagecontainerheight,
    img_url: custom_card.imageurl,
  );
  OutlineButton_param outlineButton_param1 = new OutlineButton_param(
    child: custom_card.oulineButton2child,
    radius: custom_card.oulineButton2radius,
    color: custom_card.oulineButton2color,
    function: custom_card.oulineButton2function,
    pad_val_l_wrap: custom_card.oulineButton2pad_val_l_wrap,
    pad_val_top_wrap: custom_card.oulineButton2pad_val_top_wrap,
  );
  Divider_param divider_param = new Divider_param(height: custom_card.div_height, thickness: custom_card.div_thickness, indent: custom_card.div_indent, endIndent: custom_card.div_endIndent, pad_val_top_wrap: custom_card.div_pad_val_top_wrap);

  Widget trailing_layout() {
    if (iconPrameters.size == 0 && iconPrameters1.size == 0) {
      // print('both null');
      return SizedBox.shrink();
    } else if (iconPrameters.size != 0 && iconPrameters1.size != 0) {
      //print('both not null');
      return Row(mainAxisSize: MainAxisSize.min, children: <Widget>[
        customIcon(iconPrameters),
        SizedBox(
          width: 2,
        ),
        customIcon(iconPrameters1)
      ]);
    } else if (iconPrameters.size != 0 && iconPrameters1.size == 0) {
      //print('1st not null 2nd null');
      return Row(mainAxisSize: MainAxisSize.min, children: <Widget>[
        customIcon(iconPrameters),
      ]);
    } else if (iconPrameters.size == 0 && iconPrameters1.size != 0) {
      print('1st  null 2nd not null');
      return Row(mainAxisSize: MainAxisSize.min, children: <Widget>[
        customIcon(iconPrameters1),
      ]);
    }

  }

  CusstomTiTle2 cusstomTiTle = new CusstomTiTle2(
    //leading: customIcon(iconPrameters),
    title:  (custom_card.title != null) ?
    Text(
      custom_card.title,
      style: TextStyle(fontSize: custom_card.titleFontSize),
    ):SizedBox.shrink(),
    subtitle: (custom_card.subtitle != null)
        ? Text(
      custom_card.subtitle,
      style: TextStyle(fontSize: custom_card.subtitleFontSize),
    )
        : SizedBox.shrink(),
    trailing: (custom_card.icon1_size ==0 && custom_card.icon2_size ==0) ? null: trailing_layout(),
    pad_val_top_wrap: custom_card.listTilepad_val_top_wrap,
  );

  Widget cardlayout() {
    if (outlineButton_param.child != null && outlineButton_param1.child != null && buttonParameters.child != null && custom_card.tagCloudString!=null) {
      return Column(
        children: [
          listtile(cusstomTiTle),
          Row(
            children: <Widget>[custom_Outline_button(outlineButton_param), custom_Outline_button(outlineButton_param1), customtextButton(buttonParameters)],
          ),
          Wrap(
            children: custom_card.tagCloudString
                .split(',')
                .map((String text) => Padding(
              padding: const EdgeInsets.only(left: 5,right: 5 ,top: 2,bottom: 2),
              child: Container(
                decoration: BoxDecoration(
                    color: custom_card.tagCloudColor,
                    borderRadius:  BorderRadius.all(Radius.circular(20))
                ),
                child: Padding(
                  padding: const EdgeInsets.fromLTRB(15, 5, 15, 5),
                  child: Text(text,style: TextStyle(color: custom_card.tagCloudTextColor,fontSize: 10,fontWeight: FontWeight.bold),),
                ),),
            ),) // put the text inside a widget
                .toList(),                        // convert the iterable to a list
          ),
          /* Row(
            children: [
              CustomTapCloud(tapCloudParameters),
              CustomTapCloud(tapCloudParameters1),
            ],
          ),*/
          (custom_card.div_height != null && custom_card.div_thickness != null) ? Custom_divider(divider_param) : SizedBox.shrink(),
          (custom_card.imageurl != null) ? imageContainer(containeri) : Container(),
        ],
      );
    }

    if (outlineButton_param.child == null && outlineButton_param1.child == null && buttonParameters.child == null && custom_card.tagCloudString==null) {
      return Column(
        children: [
          listtile(cusstomTiTle),
          (custom_card.div_height != null && custom_card.div_thickness != null) ? Custom_divider(divider_param) : SizedBox.shrink(),
          (custom_card.imageurl != null) ? imageContainer(containeri) : Container(),
        ],
      );
    }
    else if (outlineButton_param.child == null && outlineButton_param1.child == null && buttonParameters.child == null && (custom_card.tagCloudString!=null)) {
      return Column(
        children: [
          listtile(cusstomTiTle),

          Padding(
            padding: const EdgeInsets.only(right: 15),
            child: Wrap(
              children: custom_card.tagCloudString
                  .split(',')
                  .map((String text) => Padding(
                padding: const EdgeInsets.only(left: 5,right: 5 ,top: 2,bottom: 2),
                child: Container(
                  decoration: BoxDecoration(
                      color: custom_card.tagCloudColor,
                      borderRadius:  BorderRadius.all(Radius.circular(20))
                  ),
                  child: Padding(
                    padding: const EdgeInsets.fromLTRB(15, 5, 15, 5),
                    child: Text(text,style: TextStyle(color: custom_card.tagCloudTextColor,fontSize: 10,fontWeight: FontWeight.bold),),
                  ),),
              ),) // put the text inside a widget
                  .toList(),                        // convert the iterable to a list
            ),
          ),
          /*  Row(
            children: [
              (custom_card.tap_c1child != null) ? CustomTapCloud(tapCloudParameters) : SizedBox.shrink(),
              (custom_card.tap_c2child != null) ? CustomTapCloud(tapCloudParameters1) : SizedBox.shrink(),
            ],
          ),*/
          (custom_card.div_height != null && custom_card.div_thickness != null) ? Custom_divider(divider_param) : SizedBox.shrink(),
          (custom_card.imageurl != null) ? imageContainer(containeri) : Container(),
        ],
      );
    }
    else if (custom_card.tagCloudString==null && (outlineButton_param.child != null || outlineButton_param1.child != null || buttonParameters.child != null)) {
      return Column(
        children: [
          listtile(cusstomTiTle),
          Row(
            children: <Widget>[
              (custom_card.oulineButton1child != null) ? custom_Outline_button(outlineButton_param) : SizedBox.shrink(),
              (custom_card.oulineButton2child != null) ? custom_Outline_button(outlineButton_param1) : SizedBox.shrink(),
              (custom_card.Textchild != null) ? customtextButton(buttonParameters) : SizedBox.shrink()
            ],
          ),
          (custom_card.div_height != null && custom_card.div_thickness != null) ? Custom_divider(divider_param) : SizedBox.shrink(),
          (custom_card.imageurl != null) ? imageContainer(containeri) : Container(),
        ],
      );
    } else if (outlineButton_param.child != null || outlineButton_param1.child != null || buttonParameters.child != null || custom_card.tagCloudString!=null) {
      return Column(
        children: [
          listtile(cusstomTiTle),
          Row(
            children: <Widget>[
              (custom_card.oulineButton1child != null) ? custom_Outline_button(outlineButton_param) : SizedBox.shrink(),
              (custom_card.oulineButton2child != null) ? custom_Outline_button(outlineButton_param1) : SizedBox.shrink(),
              (custom_card.Textchild != null) ? customtextButton(buttonParameters) : SizedBox.shrink()
            ],
          ),
          Padding(
            padding: const EdgeInsets.only(right: 15),
            child: Wrap(
              children: custom_card.tagCloudString
                  .split(',')
                  .map((String text) => Padding(
                padding: const EdgeInsets.only(left: 5,right: 5 ,top: 2,bottom: 2),
                child: Container(
                  decoration: BoxDecoration(
                      color: custom_card.tagCloudColor,
                      borderRadius:  BorderRadius.all(Radius.circular(20))
                  ),
                  child: Padding(
                    padding: const EdgeInsets.fromLTRB(15, 5, 15, 5),
                    child: Text(text,style: TextStyle(color: custom_card.tagCloudTextColor,fontSize: 10,fontWeight: FontWeight.bold),),
                  ),),
              ),) // put the text inside a widget
                  .toList(),                        // convert the iterable to a list
            ),
          ),
          (custom_card.div_height != null && custom_card.div_thickness != null) ? Custom_divider(divider_param) : SizedBox.shrink(),
          (custom_card.imageurl != null) ? imageContainer(containeri) : SizedBox.shrink(),
        ],
      );
    }
  }

  Custom_Card_Container custom_card_container = Custom_Card_Container(
    //height: custom_card.cardcontainerheight,
    //width: custom_card.cardcontainerwidth,
    child: cardlayout(),
  );

  return Card(
    elevation: (custom_card.elevation != null) ? custom_card.elevation : 0,
    shape: RoundedRectangleBorder(
      borderRadius: BorderRadius.circular((custom_card.radius != null) ? custom_card.radius : 0),
    ),
    shadowColor: (custom_card.shadowcolor != null) ? custom_card.shadowcolor : Colors.white,
    child:  Custom_card_tile(custom_card_container),
  );
}



class IconPrameters{
  final IconData icon_value;
  final double size;
  final Color color;

  IconPrameters({
    this.icon_value,
    this.size,
    this.color
  });
}

Widget customIcon(IconPrameters iconPrameters){


  return Icon(
      (iconPrameters.icon_value!=null )?iconPrameters.icon_value :Icon(Icons.perm_identity_outlined),
      color: (iconPrameters.color!=null)?iconPrameters.color :Colors.grey,
      size: (iconPrameters.size!=null)?iconPrameters.size:24.0
  );


}

class outlineButtonParameters{
  final  Function onpressed;
  final Widget child;
  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;

  outlineButtonParameters({
    this.onpressed,
    this.child,
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
  });
}

Widget customtextButton(outlineButtonParameters buttonParameters){
  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (buttonParameters.pad_val_l_wrap!=null)?buttonParameters.pad_val_l_wrap:0,
        (buttonParameters.pad_val_top_wrap!=null)?buttonParameters.pad_val_top_wrap:0,
        (buttonParameters.pad_val_r_wrap!=null)?buttonParameters.pad_val_r_wrap:0,
        (buttonParameters.pad_val_bottom_wrap!=null)?buttonParameters.pad_val_bottom_wrap:0
    ),
    child: TextButton(
      child: (buttonParameters.child!=null)?buttonParameters.child:SizedBox.shrink(),
      onPressed: (buttonParameters.onpressed!=null)?buttonParameters.onpressed:(){},
    ),
  );
}
class OutlineButton_param{


  final Color color;
  final double radius;
  final Function function;
  final Widget child;

  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;

  OutlineButton_param({

    this.color,
    this.function,
    this.child,
    this.radius,
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
  });

}

Widget custom_Outline_button(OutlineButton_param outlineButton_param){

  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (outlineButton_param.pad_val_l_wrap!=null)?outlineButton_param.pad_val_l_wrap:0,
        (outlineButton_param.pad_val_top_wrap!=null)?outlineButton_param.pad_val_top_wrap:0,
        (outlineButton_param.pad_val_r_wrap!=null)?outlineButton_param.pad_val_r_wrap:0,
        (outlineButton_param.pad_val_bottom_wrap!=null)?outlineButton_param.pad_val_bottom_wrap:0
    ),
    child: OutlinedButton(
      onPressed: (outlineButton_param.function!=null)?outlineButton_param.function:(){},
      style: OutlinedButton.styleFrom(
          shape:  RoundedRectangleBorder(borderRadius: BorderRadius.all(Radius.circular(
              (outlineButton_param.radius!=null)?outlineButton_param.radius:10
          ))),
          side: BorderSide(color: (outlineButton_param.color!=null)?outlineButton_param.color :Colors.grey,)
      ),
      child: (outlineButton_param.child!=null)?outlineButton_param.child:SizedBox.shrink(),
    ),
  );
}

class Img_Container{
  final double height;
  final double width;
  final Widget child;
  final String img_url;
  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;

  Img_Container({
    this.img_url,
    this.height,
    this.child,
    this.width,
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
  });
}

Widget imageContainer(Img_Container img_container){
  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (img_container.pad_val_l_wrap!=null)?img_container.pad_val_l_wrap:0,
        (img_container.pad_val_top_wrap!=null)?img_container.pad_val_top_wrap:0,
        (img_container.pad_val_r_wrap!=null)?img_container.pad_val_r_wrap:0,
        (img_container.pad_val_bottom_wrap!=null)?img_container.pad_val_bottom_wrap:0
    ),
    child: Column(
      crossAxisAlignment: CrossAxisAlignment.stretch,
      children: [
        Container(
          // width: (img_container.width!=null)?img_container.width:10.0,
          height: (img_container.height!=null)?img_container.height:10.0,
          decoration: BoxDecoration(
              image: DecorationImage(
                  image: NetworkImage(
                    (img_container.img_url!=null)?img_container.img_url:'',
                  ),
                  fit: BoxFit.fill
              )
          ),
        ),
      ],
    ),
  );


}

class Divider_param{
  final double height;
  final double thickness;
  final double indent;
  final double endIndent;
  final Color color;
  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;

  Divider_param({
    this.height,
    this.color,
    this.thickness,
    this.endIndent,
    this.indent,
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
  });


}

Widget Custom_divider(Divider_param divider_param){
  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (divider_param.pad_val_l_wrap!=null)?divider_param.pad_val_l_wrap:0,
        (divider_param.pad_val_top_wrap!=null)?divider_param.pad_val_top_wrap:0,
        (divider_param.pad_val_r_wrap!=null)?divider_param.pad_val_r_wrap:0,
        (divider_param.pad_val_bottom_wrap!=null)?divider_param.pad_val_bottom_wrap:0
    ),
    child: Divider(
      height: (divider_param.height!=null)?divider_param.height:20,
      thickness: (divider_param.thickness!=null)?divider_param.thickness:2,
      indent: (divider_param.indent!=null)?divider_param.indent:2,
      color: (divider_param.color!=null)?divider_param.color:Colors.grey[300],
    ),
  );
}


class CusstomTiTle2{
  final Widget leading;
  final Widget title;
  final Widget subtitle;
  final Widget trailing;
  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;


  CusstomTiTle2({
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
    this.leading,
    this.title,
    this.subtitle,
    this.trailing,

  });
}


Widget listtile(CusstomTiTle2 cusstom_list_tile){
  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (cusstom_list_tile.pad_val_l_wrap!=null)?cusstom_list_tile.pad_val_l_wrap:0,
        (cusstom_list_tile.pad_val_top_wrap!=null)?cusstom_list_tile.pad_val_top_wrap:0,
        (cusstom_list_tile.pad_val_r_wrap!=null)?cusstom_list_tile.pad_val_r_wrap:0,
        (cusstom_list_tile.pad_val_bottom_wrap!=null)?cusstom_list_tile.pad_val_bottom_wrap:0
    ),
    child: (cusstom_list_tile.trailing!=null)?
    ListTile(
      trailing: (cusstom_list_tile.trailing!=null)?cusstom_list_tile.trailing:SizedBox.shrink(),
      title: (cusstom_list_tile.title!=null)?cusstom_list_tile.title:SizedBox.shrink(),
      subtitle: (cusstom_list_tile.subtitle!=null)?Padding(
        padding: const EdgeInsets.only(top: 4),
        child: cusstom_list_tile.subtitle,
      ):SizedBox.shrink(),
    ):ListTile(
      title: (cusstom_list_tile.title!=null)?cusstom_list_tile.title:SizedBox.shrink(),
      subtitle: (cusstom_list_tile.subtitle!=null)?Padding(
        padding: const EdgeInsets.only(top: 4),
        child: cusstom_list_tile.subtitle,
      ):SizedBox.shrink(),),
  );
}

class Custom_Card_Container{
  final double height;
  final double width;
  final Widget child;
  final double pad_val_all_wrap;
  final double pad_val_top_wrap;
  final double pad_val_bottom_wrap;
  final double pad_val_l_wrap;
  final double pad_val_r_wrap;



  Custom_Card_Container({
    this.pad_val_all_wrap,
    this.pad_val_top_wrap,
    this.pad_val_bottom_wrap,
    this.pad_val_l_wrap,
    this.pad_val_r_wrap,
    this.width,
    this.child,
    this.height
  });
}


Widget Custom_card_tile(Custom_Card_Container custom_card_container)
{
  return Padding(
    padding:  EdgeInsets.fromLTRB(
        (custom_card_container.pad_val_l_wrap!=null)?custom_card_container.pad_val_l_wrap:0,
        (custom_card_container.pad_val_top_wrap!=null)?custom_card_container.pad_val_top_wrap:0,
        (custom_card_container.pad_val_r_wrap!=null)?custom_card_container.pad_val_r_wrap:0,
        (custom_card_container.pad_val_bottom_wrap!=null)?custom_card_container.pad_val_bottom_wrap:0
    ),
    child: Container(
      height: (custom_card_container.height!=null)?custom_card_container.height:10,
      width: (custom_card_container.width!=null)?custom_card_container.width:10,
      child: (custom_card_container.child!=null)?custom_card_container.child:SizedBox.shrink(),
    ),
  );



}