import 'package:flutter/material.dart';

class TextParameters {
  String text;
  TextAlign textAlign;
  int maxLines;
  double fontSize;
  double height;
  Color textColor;
  FontWeight fontWeight;
  FontStyle fontStyle;
  String fontFamily;
  Color ContainerColor;
  Color BorderColor;
  double border_radius;
  double offsetdx;
  double offsetdy;
  double spread_radius;
  double blur_radius;
  Color boxshadowcolor;
  double icon1_size;
  double icon2_size;
  Color icon1_color;
  Color icon2_color;
  IconData icon1;
  IconData icon2;
  double  pad_val_all_wrap_text;
  double  pad_val_top_wrap_text;
  double  pad_val_bottom_wrap_text;
  double  pad_val_l_wrap_text;
  double  pad_val_r_wrap_text;
  double  pad_val_all_wrap_icon;
  double  pad_val_top_wrap_icon;
  double  pad_val_bottom_wrap_icon;
  double  pad_val_l_wrap_icon;
  double  pad_val_r_wrap_icon;
  double opacity;

  TextParameters({
    this.text,
    this.fontSize,
    this.height,
    this.maxLines,
    this.textColor,
    this.textAlign,
    this.fontStyle,
    this.fontWeight,
    this.fontFamily,
    this.border_radius,
    this.icon1_color,
    this.icon1_size = 0,
    this.icon2_size = 0,
    this.icon2_color,
    this.blur_radius,
    this.BorderColor,
    this.boxshadowcolor,
    this.ContainerColor,
    this.icon1,
    this.icon2,
    this.offsetdx,
    this.offsetdy,
    this.spread_radius,
    this.pad_val_all_wrap_icon,
    this.pad_val_all_wrap_text,
    this.pad_val_bottom_wrap_icon,
    this.pad_val_bottom_wrap_text,
    this.pad_val_l_wrap_icon,
    this.pad_val_l_wrap_text,
    this.pad_val_r_wrap_icon,
    this.pad_val_r_wrap_text,
    this.pad_val_top_wrap_icon,
    this.pad_val_top_wrap_text,
    this.opacity = 0,

  });
}

Widget customText(TextParameters textParameters) {
  return Container(
    decoration: BoxDecoration(
        color: (textParameters.ContainerColor!=null)?textParameters.ContainerColor:Colors.transparent,
        border: Border.all(color: (textParameters.BorderColor!=null)?textParameters.BorderColor:Colors.transparent),
        borderRadius: BorderRadius.all(
          Radius.circular((textParameters.border_radius!=null)?textParameters.border_radius:0),
        ),
        boxShadow: [
          (textParameters.opacity!=0)?BoxShadow(
            color: (textParameters.boxshadowcolor!=null)?textParameters.boxshadowcolor.withOpacity(textParameters.opacity):Colors.transparent,
            offset: const Offset(
              5.0,
              5.0,
            ),
            blurRadius: (textParameters.blur_radius!=null)?textParameters.blur_radius:0,
            spreadRadius: (textParameters.spread_radius!=null)?textParameters.spread_radius:0,
          ):BoxShadow(
            color: (textParameters.boxshadowcolor!=null)?textParameters.boxshadowcolor:Colors.transparent,
            offset: const Offset(
              5.0,
              5.0,
            ),
            blurRadius: (textParameters.blur_radius!=null)?textParameters.blur_radius:0,
            spreadRadius: (textParameters.spread_radius!=null)?textParameters.spread_radius:0,
          ), //BoxShadow
        ]
    ),
    child: Wrap(
      children: [
        //icon1
        (textParameters.icon1_size !=0)?
        Padding(
          padding:  EdgeInsets.fromLTRB(
            (textParameters.pad_val_l_wrap_icon!=null)?textParameters.pad_val_l_wrap_icon:0,
            (textParameters.pad_val_top_wrap_icon!=null)?textParameters.pad_val_top_wrap_icon:0,
            (textParameters.pad_val_r_wrap_icon!=null)?textParameters.pad_val_r_wrap_icon:0,
            (textParameters.pad_val_bottom_wrap_icon!=null)?textParameters.pad_val_bottom_wrap_icon:0,
          ),
          child: Icon(textParameters.icon1, color: (textParameters.icon1_color!=null)?textParameters.icon1_color:Colors.grey,size: textParameters.icon1_size,),
        )
            :SizedBox.shrink(),

        //TEXT
        Padding(
          padding:  EdgeInsets.fromLTRB(
            (textParameters.pad_val_l_wrap_text!=null)?textParameters.pad_val_l_wrap_text:0,
            (textParameters.pad_val_top_wrap_text!=null)?textParameters.pad_val_top_wrap_text:0,
            (textParameters.pad_val_r_wrap_text!=null)?textParameters.pad_val_r_wrap_text:0,
            (textParameters.pad_val_bottom_wrap_text!=null)?textParameters.pad_val_bottom_wrap_text:0,
          ),
          child: Text(
            (textParameters.text != null) ? textParameters.text : 'Hello',
            maxLines: (textParameters.maxLines != null) ? textParameters.maxLines : 3,
            textAlign: (textParameters.textAlign != null)
                ? textParameters.textAlign
                : TextAlign.start,
            style: TextStyle(
              height: (textParameters.height != null) ? textParameters.height : 2.5,
              color: (textParameters.textColor != null)
                  ? textParameters.textColor
                  : Colors.black,
              fontSize:
              (textParameters.fontSize != null) ? textParameters.fontSize : 12.0,
              fontWeight: (textParameters.fontWeight != null)
                  ? textParameters.fontWeight
                  : FontWeight.normal,
              fontStyle: (textParameters.fontStyle != null)
                  ? textParameters.fontStyle
                  : FontStyle.normal,
              fontFamily: (textParameters.fontFamily != null)
                  ? textParameters.fontFamily
                  : 'Roboto',
            ),
          ),
        ),

        //icon2

        (textParameters.icon2_size !=0)?
        Padding(
          padding:  EdgeInsets.fromLTRB(
            (textParameters.pad_val_l_wrap_icon!=null)?textParameters.pad_val_l_wrap_icon:0,
            (textParameters.pad_val_top_wrap_icon!=null)?textParameters.pad_val_top_wrap_icon:0,
            (textParameters.pad_val_r_wrap_icon!=null)?textParameters.pad_val_r_wrap_icon:0,
            (textParameters.pad_val_bottom_wrap_icon!=null)?textParameters.pad_val_bottom_wrap_icon:0,
          ),
          child: Icon(textParameters.icon2,color: (textParameters.icon2_color!=null)?textParameters.icon2_color:Colors.grey,size: textParameters.icon2_size,),
        )
            :SizedBox.shrink(),
      ],
    ),
  );
}


/*
Text(
(textParameters.text != null) ? textParameters.text : 'Hello',
maxLines: (textParameters.maxLines != null) ? textParameters.maxLines : 3,
textAlign: (textParameters.textAlign != null)
? textParameters.textAlign
    : TextAlign.start,
style: TextStyle(
height: (textParameters.height != null) ? textParameters.height : 1.0,
color: (textParameters.textColor != null)
? textParameters.textColor
    : Colors.black,
fontSize:
(textParameters.fontSize != null) ? textParameters.fontSize : 12.0,
fontWeight: (textParameters.fontWeight != null)
? textParameters.fontWeight
    : FontWeight.normal,
fontStyle: (textParameters.fontStyle != null)
? textParameters.fontStyle
    : FontStyle.normal,
fontFamily: (textParameters.fontFamily != null)
? textParameters.fontFamily
    : 'Roboto',
),
),*/
